#include <sourcemod>
#include <sdktools>
#include <gungame>

new String:g_sSkinT[PLATFORM_MAX_PATH];
new String:g_sSkinCT[PLATFORM_MAX_PATH];

//new Handle:hDefaultTmodel, Handle:hDefaultCTmodel;
new Handle:hKnifeTmodel, Handle:hKnifeCTmodel;

new bool:HasKnife[MAXPLAYERS+1];

public Plugin:myinfo =
{
	name = "GunGame Skin",
	author = "SemJef",
	version = "0.6.0",
	url = "http://www.semjef.ru/"
}

public OnPluginStart()
{
	//hDefaultTmodel =	CreateConVar("gg_DefaultTmodel", 	"models/player/t_phoenix.mdl", 	"  ", FCVAR_PLUGIN);
	//hDefaultCTmodel =	CreateConVar("gg_DefaultCTmodel", 	"models/player/ct_urban.mdl", 	"  ", FCVAR_PLUGIN);
	
	hKnifeTmodel =		CreateConVar("gg_KnifeTmodel", 		"models/player/t_phoenix.mdl", 	"  ", FCVAR_PLUGIN);
	hKnifeCTmodel =		CreateConVar("gg_KnifeCTmodel", 	"models/player/ct_urban.mdl", 	"  ", FCVAR_PLUGIN);
	
	HookEvent("player_spawn",	Event_PlayerSpawn);
	
	AutoExecConfig(true, "gg_skins");
}

public OnMapStart()
{	
	ReadDownloadsSimple();
}

public OnConfigsExecuted()
{
	//GetConVarString(hDefaultTmodel, g_sSkinT[0], PLATFORM_MAX_PATH);
	//GetConVarString(hDefaultCTmodel, g_sSkinCT[0], PLATFORM_MAX_PATH);
	
	GetConVarString(hKnifeTmodel, g_sSkinT, PLATFORM_MAX_PATH);
	GetConVarString(hKnifeCTmodel, g_sSkinCT, PLATFORM_MAX_PATH);
	
	//PrecacheModel(g_sSkinCT[0], true);
	//PrecacheModel(g_sSkinT[0], true);
	PrecacheModel(g_sSkinCT, true);
	PrecacheModel(g_sSkinT, true);
	
}

public OnClientPostAdminCheck(client)
{
	HasKnife[client] = false;
}

public Action:Event_PlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if(HasKnife[client])
	{
		if(GetClientTeam(client) == 3)
		{
			if(!IsModelPrecached(g_sSkinCT))
			{
				PrecacheModel(g_sSkinCT, true);
			}
			SetEntityModel(client, g_sSkinCT);
		}
		else if(GetClientTeam(client) == 2)
		{
			if(!IsModelPrecached(g_sSkinT))
			{
				PrecacheModel(g_sSkinT, true);
			}
			SetEntityModel(client, g_sSkinT);
		}
	}
}

public Action:GG_OnClientLevelChange(client, level, difference, bool:steal, bool:last, bool:knife)
{
	//Debug(1, "%d %d %d %d %d %d %s", client, level, difference, BoolToInt(steal), BoolToInt(last), BoolToInt(knife), buffer);
	HasKnife[client] = knife;
	if(knife)
	{
		if(GetClientTeam(client) == 3)
		{
			if(!IsModelPrecached(g_sSkinCT))
			{
				PrecacheModel(g_sSkinCT, true);
			}
			SetEntityModel(client, g_sSkinCT);
		}
		else if(GetClientTeam(client) == 2)
		{
			if(!IsModelPrecached(g_sSkinT))
			{
				PrecacheModel(g_sSkinT, true);
			}
			SetEntityModel(client, g_sSkinT);
		}
	}
}

stock BoolToInt(bool:b)
{
	if(b)
		return 1;
	else
		return 0;
}

stock ReadDownloadsSimple()
{
	new String:file[256];
	BuildPath(Path_SM, file, 255, "configs/gg_knife_skin.cfg");
	new Handle:fileh = OpenFile(file, "r");
	new String:buffer[256];
	new len;
	
	if(fileh == INVALID_HANDLE) return;
	while (ReadFileLine(fileh, buffer, sizeof(buffer)))
	{
		len = strlen(buffer);
		if (buffer[len-1] == '\n')
		{
			buffer[--len] = '\0';
		}
		
		TrimString(buffer);

		if(!StrEqual(buffer,"",false))
		{
			ReadFileFolder(buffer);
		}
		
		if (IsEndOfFile(fileh))
		{
			break;
		}
	}
	if(fileh != INVALID_HANDLE){
		CloseHandle(fileh);
	}
}

ReadFileFolder(String:path[])
{
	new Handle:dirh = INVALID_HANDLE;
	new String:buffer[256];
	new String:tmp_path[256];
	new FileType:type = FileType_Unknown;
	new len;
	
	len = strlen(path);
	if (path[len-1] == '\n')
	{
		path[--len] = '\0';
	}
	
	TrimString(path);
	
	if(DirExists(path))
	{
		dirh = OpenDirectory(path);
		while(ReadDirEntry(dirh,buffer,sizeof(buffer),type))
		{
			len = strlen(buffer);
			if (buffer[len-1] == '\n')
			{
				buffer[--len] = '\0';
			}
			
			TrimString(buffer);

			if (!StrEqual(buffer,"",false) && !StrEqual(buffer,".",false) && !StrEqual(buffer,"..",false))
			{
				strcopy(tmp_path,255,path);
				StrCat(tmp_path,255,"/");
				StrCat(tmp_path,255,buffer);
				if(type == FileType_File)
				{
					ReadItemSimple(tmp_path);
				}
				else
				{
					ReadFileFolder(tmp_path);
				}
			}
		}
	}
	else
	{
		ReadItemSimple(path);
	}
	if(dirh != INVALID_HANDLE)
	{
		CloseHandle(dirh);
	}
}

ReadItemSimple(String:buffer[])
{
	new len = strlen(buffer);
	if (buffer[len-1] == '\n')
	{
		buffer[--len] = '\0';
	}
	TrimString(buffer);
	if(len >= 2 && buffer[0] == '/' && buffer[1] == '/')
	{
		//Comment
	}
	else if (!StrEqual(buffer,"",false) && FileExists(buffer))
	{
		AddFileToDownloadsTable(buffer);
	}
}